package com.sun.imageio.stream;

import javax.imageio.stream.ImageInputStream;
import java.security.AccessController;
import java.security.PrivilegedAction;
import java.util.Set;
import java.io.IOException;
import java.util.WeakHashMap;

public class StreamCloser
{
    private static WeakHashMap<StreamCloser.CloseAction, Object> toCloseQueue;
    private static Thread streamCloser;
    
    public StreamCloser() {
    }
    
    public static void addToQueue(StreamCloser.CloseAction key) {
        synchronized (StreamCloser.class) {
            if (StreamCloser.toCloseQueue == null) {
                StreamCloser.toCloseQueue = new WeakHashMap();
            }
            StreamCloser.toCloseQueue.put(key, null);
            if (StreamCloser.streamCloser == null) {
                AccessController.doPrivileged(new PrivilegedAction() {
                    
                    @Override
                    public Object run() {
                        ThreadGroup group;
                        for (group = (group = Thread.currentThread().getThreadGroup()); group != null; , group = group.getParent()) {}
                        StreamCloser.streamCloser = new Thread(group, streamCloserRunnable);
                        StreamCloser.streamCloser.setContextClassLoader(null);
                        Runtime.getRuntime().addShutdownHook(StreamCloser.streamCloser);
                        return null;
                    }
                });
            }
        }
    }
    
    public static void removeFromQueue(StreamCloser.CloseAction key) {
        synchronized (StreamCloser.class) {
            if (StreamCloser.toCloseQueue != null) {
                StreamCloser.toCloseQueue.remove(key);
            }
        }
    }
    
    public static StreamCloser.CloseAction createCloseAction(ImageInputStream imageInputStream) {
        return new CloseAction(imageInputStream);
    }
    
    public static final class CloseAction
    {
        private ImageInputStream iis;
        
        private CloseAction(ImageInputStream iis) {
            this.iis = iis;
        }
        
        public void performAction() throws IOException {
            if (this.iis != null) {
                this.iis.close();
            }
        }
    }
}
